%define anolis_release 1

%global glib2_version 2.66.0
%global gobject_introspection_version 1.66.0
%global mozjs102_version 102.9.0

%bcond_with check

Name:           gjs
Version:        1.76.0
Release:        %{anolis_release}%{dist}

Summary:        Javascript Bindings for GNOME

# The following files contain code from Mozilla which
# is triple licensed under MPL1.1/LGPLv2+/GPLv2+:
# The console module (modules/console.c)
# Stack printer (gjs/stack.c)
License:        MIT and (MPLv1.1 or GPLv2+ or LGPLv2+)
URL:            https://wiki.gnome.org/Projects/Gjs
Source0:        https://download.gnome.org/sources/%{name}/1.76/%{name}-%{version}.tar.xz

BuildRequires:  gcc-c++
BuildRequires:  meson
BuildRequires:  gettext
BuildRequires:  readline-devel
BuildRequires:  pkgconfig(cairo-gobject)
BuildRequires:  pkgconfig(gio-2.0) >= %{glib2_version}
BuildRequires:  pkgconfig(gobject-introspection-1.0) >= %{gobject_introspection_version}
BuildRequires:  pkgconfig(gtk4)
BuildRequires:  pkgconfig(mozjs-102) >= %{mozjs102_version}
BuildRequires:  pkgconfig(sysprof-capture-4)
# For GTK+ 3 tests
BuildRequires:  gtk3
# For dbus tests
BuildRequires:  /usr/bin/dbus-run-session
#dbus-x11, xvfb, mesa-dri-drivers for test suite
BuildRequires:  dbus-x11
BuildRequires:  mesa-dri-drivers
BuildRequires:  xorg-x11-server-Xvfb

Requires: glib2 >= %{glib2_version}
Requires: gobject-introspection >= %{gobject_introspection_version}
Requires: mozjs102 >= %{mozjs102_version}

%description
Gjs allows using GNOME libraries from Javascript. It's based on the
Spidermonkey Javascript engine from Mozilla and the GObject introspection
framework.

%package devel
Summary: Development package for %{name}
Requires: %{name} = %{version}-%{release}

%description devel
Files for development with %{name}.

%package tests
Summary: Tests for the gjs package
Requires: %{name} = %{version}-%{release}

%description tests
The gjs-tests package contains tests that can be used to verify
the functionality of the installed gjs package.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1

%build
%meson
%meson_build

%install
%meson_install

%check
%if %{with check}
%{shrink:xvfb-run -s "-screen 0 1600x1200x24" %meson_test --timeout-multiplier=5}
%endif

%generate_compatibility_deps

%files
%license COPYING
%dir %{abidir}
%{_bindir}/gjs
%{_bindir}/gjs-console
%{abidir}/gjs-console-option.list
%{_libdir}/gjs/
%{_libdir}/libgjs.so.0*
%{abidir}/lib*.dump

%files devel
%doc examples/*
%{_includedir}/gjs-1.0
%{_libdir}/pkgconfig/gjs-1.0.pc
%{_libdir}/libgjs.so
%dir %{_datadir}/gjs-1.0
%{_datadir}/gjs-1.0/lsan/
%{_datadir}/gjs-1.0/valgrind/

%files tests
%{_libexecdir}/installed-tests/
%{_datadir}/glib-2.0/schemas/org.gnome.GjsTest.gschema.xml
%{_datadir}/installed-tests/

%files doc
%doc NEWS README.md

%changelog
* Mon Mar 20 2023 yuanhui <yuanhui@linux.alibaba.com> - 1.76.0-1
- Init package from upstream
